
#!/usr/bin/python
# -*- coding: utf-8 -*-

from time import *
import os, logging, sys, smbus
logging.basicConfig(filename='i2c.log', level=logging.INFO, format='%(asctime)s %(message)s', datefmt='%y.%m.%d %H:%M:%S ' )
logging.info('*** Programm neu gestartet ! ***')

# Stand 30.03.2018 Modulansteuerung Demo I2C-Fuellstandsmesser
# jede Veraenderung am PCF8574P wird angezeigt und im Loggerfile
# mit Datum und Zeit gespeichert
# eine vieradrige Leitung ist notwendig
#
# 3,3 Pin Raspi - Steuermodul
# SDA Pin Raspi - Steuermodul
# SCL PIN Raspi - Steuermodul
# GND PIN Raspi - Steuermodul
#
# Bitbelegung PCF8574P am I2C Steuermodul
# E0 - Bit 0 (Datenwert 1)
# E1 - Bit 1 (Datenwert 2)
# E2 - Bit 2 (Datenwert 4)
# E3 - Bit 3 (Datenwert 8)
# E4 - Bit 4 (Datenwert 16)
# E5 - Bit 5 (Datenwert 32)
# E6 - Bit 6 (Datenwert 64)
# E7 - Bit 7 (wenn high - dann Datenwert uebernehmen)

# I2C Bus initialisieren
bus = smbus.SMBus(1)
data_old = 0
data_neu = 1
info = ''

s_text = ''								# stringspeicher anlegen

# Start Dauerschleife
while (1):
  while (data_old == data_neu):						# hat sich was geaendert
    data = bus.read_byte(0x27)						# bitwerte vom pcf8574 einlesen
    if data>127:							# fehlersignal Bit7 (1=ok 0=Fehler)
      info = 'kein Fehler'
    else:
      info = 'Fehler'
    data_neu = 0x7f & data						# Prozentwert uebernehmen
  data_old = data_neu
  s_text = 'Fuellstand = ' + "%2.0f" % data_old + ' Prozent ' + info    # string zusammenstellen
  print (s_text)							# Bildschirmausgabe
  logging.info (s_text)							# Ausgabe in Logfile

